<?php

namespace App\DataTables;

use App\Models\Categoriacontabile;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class CategoriacontabileDataTableEditor extends DataTablesEditor
{
  protected $model = Categoriacontabile::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'descrizione.required' => 'La descrizione è richiesta',
    'is_attiva.required' => 'Indicare una delle due opzioni',
    'nome.unique' => 'Categoria già esistente',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => [
        'required',
        Rule::unique('categoria_contabile', 'nome')
            ->where('attivita_id', $data['attivita_id'] ?? null),
      ],
      'descrizione' => 'nullable',
      'is_attiva' => 'boolean',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome' => [
        'required',
        Rule::unique('categoria_contabile', 'nome')
        ->where('attivita_id', $model->attivita_id)
        ->ignore($model->id),
      ],
      'descrizione' => 'nullable',
      'is_attiva' => 'boolean',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attiva'] = isset($data['is_attiva']) ? true : false;
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
